Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/PropertiesSelector.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/PropertiesSelector.java	(revision 2947)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/PropertiesSelector.java	(revision 2948)
@@ -49,6 +49,7 @@
 import org.txm.searchengine.cqp.corpus.CQPCorpus;
 import org.txm.searchengine.cqp.corpus.Property;
 import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
+import org.txm.searchengine.cqp.corpus.VirtualProperty;
 import org.txm.utils.logger.Log;
 
 /**
@@ -167,11 +168,11 @@
 				buffer.append(propSeparator);
 			}
 			
-			if (p instanceof StructuralUnitProperty)
-				buffer.append(((StructuralUnitProperty) p).getFullName());
-			else
+			if (p instanceof StructuralUnitProperty || p instanceof VirtualProperty) {
+				buffer.append(p.getFullName());
+			} else {
 				buffer.append(p.getName());
-			
+			}			
 		}
 		if (buffer.length() > 0) {
 			int l = buffer.length();
@@ -233,6 +234,8 @@
 					i--;
 				}
 			}
+			
+			availableProperties.addAll((Collection<? extends P>) corpus.getVirtualProperties());
 		}
 		catch (CqiClientException e) {
 			Log.severe(NLS.bind(TXMUIMessages.cantLoadPropertiesFromCorpusP0ColonP1, e.getMessage()));
@@ -292,7 +295,7 @@
 	 * 
 	 * @param available a list of properties set to the this.availableProperties list
 	 */
-	public void setProperties(List<P> available) {
+	public final void setProperties(List<P> available) {
 		this.setProperties(available, new ArrayList<P>());
 	}
 	
Index: tmp/org.txm.referencer.rcp/src/org/txm/referencer/rcp/editors/ReferencerEditor.java
===================================================================
--- tmp/org.txm.referencer.rcp/src/org/txm/referencer/rcp/editors/ReferencerEditor.java	(revision 2947)
+++ tmp/org.txm.referencer.rcp/src/org/txm/referencer/rcp/editors/ReferencerEditor.java	(revision 2948)
@@ -159,8 +159,7 @@
 		// [Edit]
 		propertiesSelector = new PropertiesSelector<>(getMainParametersComposite(), SWT.NONE);
 		propertiesSelector.setMaxPropertyNumber(1);
-		propertiesSelector.setLayoutData(new GridData(GridData.FILL, GridData.FILL,
-				false, false));
+		propertiesSelector.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
 		propertiesSelector.setLayout(new GridLayout(3, false));
 		propertiesSelector.addSelectionListener(computeSelectionListener);
 		
@@ -428,6 +427,7 @@
 			ArrayList<Property> selectedProps = new ArrayList<>();
 			ArrayList<Property> availables = new ArrayList<>();
 			availables.addAll(corpus.getOrderedProperties());
+			availables.addAll(corpus.getVirtualProperties());
 			
 			if (referencer.getProperty() != null) {
 				selectedProps.add(referencer.getProperty());
Index: tmp/org.txm.index.core/src/org/txm/index/core/functions/Lexicon.java
===================================================================
--- tmp/org.txm.index.core/src/org/txm/index/core/functions/Lexicon.java	(revision 2947)
+++ tmp/org.txm.index.core/src/org/txm/index/core/functions/Lexicon.java	(revision 2948)
@@ -83,11 +83,11 @@
 			// this.query = new Query("[]"); //$NON-NLS-1$
 			// this.props = new ArrayList<Property>();
 			// this.props.add(property);
-			Property property = this.pProperties.get(0);
+			WordProperty property = this.pProperties.get(0);
 			
 			CQPLexicon lexicon = CQPLexicon.getLexicon(this.getCorpus(), property, monitor.createNewMonitor(20));
-			lexicon.setProperty(property);
-			lexicon._compute();
+			//lexicon.setProperty(property);
+			//lexicon._compute();
 			
 			this.nTotalTokens = lexicon.nbrOfToken();
 			String[] forms = lexicon.getForms();
Index: tmp/org.txm.index.core/src/org/txm/index/core/functions/PartitionIndex.java
===================================================================
--- tmp/org.txm.index.core/src/org/txm/index/core/functions/PartitionIndex.java	(revision 2947)
+++ tmp/org.txm.index.core/src/org/txm/index/core/functions/PartitionIndex.java	(revision 2948)
@@ -39,7 +39,6 @@
 import org.eclipse.osgi.util.NLS;
 import org.rosuda.REngine.REXPMismatchException;
 import org.txm.core.messages.TXMCoreMessages;
-import org.txm.core.preferences.TXMPreferences;
 import org.txm.index.core.functions.LineComparator.SortMode;
 import org.txm.index.core.messages.IndexCoreMessages;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
Index: tmp/org.txm.index.core/src/org/txm/index/core/functions/Index.java
===================================================================
--- tmp/org.txm.index.core/src/org/txm/index/core/functions/Index.java	(revision 2947)
+++ tmp/org.txm.index.core/src/org/txm/index/core/functions/Index.java	(revision 2948)
@@ -251,23 +251,41 @@
 		for (int t = 0; t < nbToken; t++) {
 			query += "["; //$NON-NLS-1$
 			for (int p = 0; p < nbProps; p++) {
+				
 				if (props.get(p) instanceof StructuralUnitProperty) {
 					query += "_." + ((StructuralUnitProperty) props.get(p)).getFullName() + "=\""; //$NON-NLS-1$ //$NON-NLS-2$
+					
+					for (int l = 0; l < nbLines; l++) {
+						line = lines.get(l);
+						List<List<String>> values = line.getUnitsProperties();
+						String s = values.get(p).get(t);
+						s = CQLQuery.addBackSlash(s);
+						query += s + "|"; //$NON-NLS-1$
+					}
+					query = query.substring(0, query.length() - 1);
+					
+					query += "\""; //$NON-NLS-1$
+				
 				}
-				else {
-					query += props.get(p) + "=\""; //$NON-NLS-1$
+				else if (props.get(p) instanceof WordProperty) {
+					ArrayList<String> values = new ArrayList<>();
+					for (int l = 0; l < nbLines; l++) {
+						line = lines.get(l);
+						String s = line.getUnitsProperties().get(p).get(t);
+						values.add(s);
+					}
+					
+					String test = ((WordProperty)props.get(p)).getCQLTest(values);
+					if (test != null) {
+						query += test;
+					}
 				}
-				for (int l = 0; l < nbLines; l++) {
-					line = lines.get(l);
-					List<List<String>> values = line.getUnitsProperties();
-					String s = values.get(p).get(t);
-					s = CQLQuery.addBackSlash(s);
-					query += s + "|"; //$NON-NLS-1$
+				
+				if (p < nbProps-1) {
+					query += " & "; //$NON-NLS-1$
 				}
-				query = query.substring(0, query.length() - 1);
-				query += "\" & "; //$NON-NLS-1$
 			}
-			query = query.substring(0, query.length() - 3);
+			
 			query += "] "; //$NON-NLS-1$
 		}
 		query = query.substring(0, query.length() - 1);
@@ -292,13 +310,20 @@
 			for (int t = 0; t < nbToken; t++) {
 				query += "["; //$NON-NLS-1$
 				for (int p = 0; p < nbProps; p++) {
-					query += props.get(p).getName() + "=\""; //$NON-NLS-1$
-					String s = values.get(p).get(t);
-					s = CQLQuery.addBackSlash(s);
-					query += s;
-					query += "\" & "; //$NON-NLS-1$
+					
+					if (props.get(p) instanceof WordProperty) {
+						String s = line.getUnitsProperties().get(p).get(t);
+						
+						String test = ((WordProperty)props.get(p)).getCQLTest(s);
+						if (test != null) {
+							query += test;
+						}
+					}
+										
+					if (p < nbProps -1) {
+						query += " & "; //$NON-NLS-1$
+					}
 				}
-				query = query.substring(0, query.length() - 3);
 				query += "] "; //$NON-NLS-1$
 			}
 			queries.add(new CQLQuery(query));
@@ -588,8 +613,8 @@
 					if (property instanceof StructuralUnitProperty) {
 						strs = CorpusManager.getCorpusManager().getCqiClient().struc2Str(property.getQualifiedName(), indices);
 					}
-					else {
-						strs = CorpusManager.getCorpusManager().getCqiClient().id2Str(property.getQualifiedName(), indices);
+					else if (property instanceof WordProperty) {
+						strs = ((WordProperty)property).id2Str(indices);
 					}
 				}
 				catch (Exception e) {
@@ -710,7 +735,7 @@
 	
 	@Override
 	public String getComputingStartMessage() {
-		return TXMCoreMessages.bind(IndexCoreMessages.indexOfP0PropertiesP1InTheP2Corpus, this.pQuery.asString(), WordProperty.asString(this.pProperties), this.getCorpus().getName());
+		return TXMCoreMessages.bind(IndexCoreMessages.indexOfP0PropertiesP1InTheP2Corpus, (this.pQuery!=null?this.pQuery.asString():"<no query>"), WordProperty.asString(this.pProperties), this.getCorpus().getName());
 	}
 	
 	
@@ -826,8 +851,8 @@
 					int[] structs = CorpusManager.getCorpusManager().getCqiClient().cpos2Struc(property.getQualifiedName(), allpositionsarray);
 					propsId.put(property, structs);
 				}
-				else {
-					int[] indices = CorpusManager.getCorpusManager().getCqiClient().cpos2Id(property.getQualifiedName(), allpositionsarray);
+				else if (property instanceof WordProperty) {
+					int[] indices = ((WordProperty)property).cpos2Id(allpositionsarray);
 					propsId.put(property, indices);
 				}
 			}
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/CQPLexicon.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/CQPLexicon.java	(revision 2947)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/CQPLexicon.java	(revision 2948)
@@ -35,6 +35,7 @@
 import java.io.UnsupportedEncodingException;
 import java.util.ArrayList;
 import java.util.Arrays;
+import java.util.HashSet;
 import java.util.Map;
 
 import org.eclipse.core.runtime.IProgressMonitor;
@@ -61,53 +62,87 @@
  * @author sloiseau
  */
 public class CQPLexicon {
-	
-	
+
+
 	/** The forms. */
 	private String[] forms;
-	
+
 	/** The freqs. */
 	private int[] freqs;
-	
+
 	/** The ids. */
 	private int[] ids;
-	
+
 	/** The number of tokens. */
 	int numberOfTokens = -1;
-	
+
 	/** The symbol. */
 	private String symbol;
-	
+
 	/** The writer. */
 	private OutputStreamWriter writer;
-	
+
 	/**
 	 * The property.
 	 */
-	protected Property pProperty;
-	
+	protected WordProperty pProperty;
+
 	private CQPCorpus corpus;
-	
+
 	/**
 	 * @param corpus
 	 */
 	public CQPLexicon(CQPCorpus corpus) {
 		this.corpus = corpus;
 	}
-	
+
 	public boolean _compute() throws Exception {
-		if (this.getParent() instanceof MainCorpus) {
-			return computeWithMainCorpus((MainCorpus) this.getParent(), pProperty, null);
+
+		if (pProperty instanceof VirtualProperty) {
+			return computeWithVirtualProperty(this.getParent(), (VirtualProperty)pProperty);
+		} else {
+			if (this.getParent() instanceof MainCorpus) {
+				return computeWithMainCorpus((MainCorpus) this.getParent(), pProperty, null); // uses CQi fdist method
+			}
+			else if (this.getParent() instanceof Subcorpus) {
+				return computewithSubCorpus((Subcorpus) this.getParent(), pProperty, null); // uses CQi fdist method
+			}
+			else {
+				Log.severe("Error: Lexicon parent is neither a Maincorpus nor a Subcorpus."); //$NON-NLS-1$
+				return false;
+			}
 		}
-		else if (this.getParent() instanceof Subcorpus) {
-			return computewithSubCorpus((Subcorpus) this.getParent(), pProperty, null);
+	}
+
+	private boolean computeWithVirtualProperty(CQPCorpus corpus, VirtualProperty property) {
+
+		int[] positions = MatchUtils.toPositions(corpus.getMatches());
+		int[] ids2 = property.cpos2Id(positions);
+		Arrays.sort(ids2);
+		HashSet<Integer> test = new HashSet<Integer>();
+		int[] freqs2 = new int[ids2.length]; // max freqs length
+		int[] idsHash = new int[ids2.length]; // max idsHash length
+		idsHash[0] = ids2[0];
+		int n = 0; // max size
+		for (int i = 0 ; i < ids2.length ; i++) {
+			test.add(ids2[i]);
+			if (idsHash[n] != ids2[i]) { // new entry
+				n++;
+				idsHash[n] = ids2[i];
+			}
+			freqs2[n] = freqs2[n] + 1;
 		}
-		else {
-			Log.severe("Error: Lexicon parent is neither a Maincorpus nor a Subcorpus."); //$NON-NLS-1$
-			return false;
-		}
+			
+		ids = new int[n];
+		System.arraycopy(idsHash, 0, ids, 0, n);
+		freqs = new int[n];
+		System.arraycopy(freqs2, 0, freqs, 0, n);
+			
+		init(corpus, property, freqs, ids);
+		return true;
+
 	}
-	
+
 	/**
 	 * Gets the lexicon relative to a given property.
 	 * 
@@ -119,7 +154,7 @@
 	 * @throws CqiClientException
 	 *             the cqi client exception
 	 */
-	protected boolean computeWithMainCorpus(MainCorpus corpus, Property property, IProgressMonitor monitor) throws CqiClientException {
+	protected boolean computeWithMainCorpus(MainCorpus corpus, WordProperty property, IProgressMonitor monitor) throws CqiClientException {
 		// System.out.println("in "+this.getCqpId()+" look for cached lexicon "+property);
 		// System.out.println("not found");
 		int lexiconSize;
@@ -129,12 +164,12 @@
 		catch (Exception e) {
 			throw new CqiClientException(e);
 		}
-		
+
 		int[] ids = new int[lexiconSize];
 		for (int i = 0; i < ids.length; i++) {
 			ids[i] = i;
 		}
-		
+
 		int[] freqs;
 		try {
 			freqs = CorpusManager.getCorpusManager().getCqiClient().id2Freq(property.getQualifiedName(), ids);
@@ -142,11 +177,11 @@
 		catch (Exception e) {
 			throw new CqiClientException(e);
 		}
-		
+
 		this.init(corpus, property, freqs, ids);
 		return true;
 	}
-	
+
 	// /**
 	// *
 	// * @param corpus
@@ -197,7 +232,7 @@
 	// init(corpus, property, freqs, ids);
 	// return true;
 	// }
-	
+
 	/**
 	 * 
 	 * @param corpus
@@ -208,26 +243,26 @@
 	 */
 	// FIXME: SJ: why this method needs to create and delete some new subcorpus? the computing can't be done directly on the corpus argument?
 	// eg. dist = CorpusManager.getCorpusManager().getCqiClient().fdist1(corpus.getQualifiedCqpId(), 0, ICqiClient.CQI_CONST_FIELD_MATCH, property.getName());
-	protected boolean computewithSubCorpus(Subcorpus corpus, Property property, IProgressMonitor monitor) throws CqiClientException {
-		
+	protected boolean computewithSubCorpus(Subcorpus corpus, WordProperty property, IProgressMonitor monitor) throws CqiClientException {
+
 		// System.out.println("not found");
 		// Log.finest(NLS.bind(IndexCoreMessages.computingTheLexiconOfSubcorpusP0, corpus.getName()));
 		// long start = System.currentTimeMillis();
 		int[][] fdist = null;
-		
+
 		boolean fast = false;
-		
+
 		// FIXME: SJ: old version
 		if (!fast) {
-			
+
 			AbstractCqiClient cqi = CorpusManager.getCorpusManager().getCqiClient();
 			String tmp = "TMP" + CQPCorpus.getNextSubcorpusCounter();
 			String qtmp = corpus.getMainCorpus().getQualifiedCqpId() + ":" + tmp;
-			
+
 			try {
 				// System.out.println("subcorpus: "+corpus.getQualifiedCqpId());
 				// System.out.println("query subcorpus: "+qtmp);
-				
+
 				cqi.cqpQuery(corpus.getQualifiedCqpId(), tmp, "[]"); //$NON-NLS-1$
 				fdist = CorpusManager.getCorpusManager().getCqiClient().fdist1(qtmp, 0, ICqiClient.CQI_CONST_FIELD_MATCH, property.getName());
 				// System.out.println("nb lines: "+fdist.length);
@@ -251,7 +286,7 @@
 		}
 		// FIXME: SJ: new version by MD that seems fastest, need to test on all types of lexicons corpora before replacing old version
 		else {
-			
+
 			try {
 				int[] positions = MatchUtils.toPositions(corpus.getMatches());
 				int[] indexes = CorpusManager.getCorpusManager().getCqiClient().cpos2Id(property.getQualifiedName(), positions);
@@ -261,7 +296,7 @@
 					counts[i]++;
 				}
 				fdist = new int[indexes.length][2];
-				
+
 				int n = 0;
 				for (int i : indexes) {
 					fdist[n][0] = i;
@@ -275,19 +310,19 @@
 			}
 		}
 		int lexiconSize = fdist.length;
-		
+
 		int[] freqs = new int[lexiconSize];
 		int[] ids = new int[lexiconSize];
 		for (int i = 0; i < fdist.length; i++) {
 			ids[i] = fdist[i][0];
 			freqs[i] = fdist[i][1];
 		}
-		
+
 		init(corpus, property, freqs, ids);
 		return true;
 	}
-	
-	
+
+
 	/**
 	 * Compute number of tokens. / this.nbr
 	 */
@@ -299,7 +334,7 @@
 			// if (freqs[i] != 1) System.out.println(freqs[i]);
 		}
 	}
-	
+
 	/**
 	 * Dump lexicon forms and frequencies in a String.
 	 *
@@ -315,7 +350,7 @@
 		}
 		return buffer.toString();
 	}
-	
+
 	/*
 	 * (non-Javadoc)
 	 * @see java.lang.Object#equals(java.lang.Object)
@@ -326,13 +361,13 @@
 			return false;
 		}
 		CQPLexicon other = (CQPLexicon) obj;
-		
+
 		if (other.nbrOfType() != this.nbrOfType()) {
 			return false;
 		}
 		return (Arrays.equals(freqs, other.getFreq()) && Arrays.equals(getForms(), other.getForms()));
 	}
-	
+
 	/**
 	 * The corpus or subcorpus this lexicon is build on.
 	 * 
@@ -341,12 +376,12 @@
 	public CQPCorpus getCorpus() {
 		return corpus;
 	}
-	
-	
+
+
 	public String getDetails() {
 		return this.getParent().getName() + " " + this.pProperty.getName(); //$NON-NLS-1$
 	}
-	
+
 	// TODO: move this into a Lexicon chart renderer
 	// /**
 	// * Draw a pareto graphic with this frequency list and record it into the
@@ -365,9 +400,9 @@
 	// throw new StatException(e);
 	// }
 	// }
-	
+
 	/**
-	 * The dif ferent types in the lexicon, the type at the index <code>j</code>
+	 * The different types in the lexicon, the type at the index <code>j</code>
 	 * of this array have the frequency at index <code>j</code> in the array
 	 * returned by {@link #getFreq()}.
 	 * 
@@ -379,7 +414,9 @@
 				return new String[0];
 			}
 			try {
-				forms = CorpusManager.getCorpusManager().getCqiClient().id2Str(pProperty.getQualifiedName(), ids);
+				if (pProperty instanceof WordProperty) {
+					forms = ((WordProperty)pProperty).id2Str(ids);
+				}				
 			}
 			catch (Exception e) {
 				// TODO Auto-generated catch block
@@ -388,7 +425,7 @@
 		}
 		return forms;
 	}
-	
+
 	/**
 	 * The dif ferent types in the lexicon, the type at the index <code>j</code>
 	 * of this array have the frequency at index <code>j</code> in the array
@@ -425,7 +462,7 @@
 			return subforms;
 		}
 	}
-	
+
 	/**
 	 * The dif ferent frequencies in the lexicon. See {@link #getForms()}.
 	 * 
@@ -434,7 +471,7 @@
 	public int[] getFreq() {
 		return freqs;
 	}
-	
+
 	/**
 	 * return the ids of the entries.
 	 *
@@ -443,7 +480,7 @@
 	public int[] getIds() {
 		return ids;
 	}
-	
+
 	public String getName() {
 		try {
 			return this.corpus.getSimpleName() + ": " + this.getSimpleName();
@@ -452,7 +489,7 @@
 		}
 		return ""; //$NON-NLS-1$
 	}
-	
+
 	/**
 	 * The property this lexicon is build on.
 	 * 
@@ -461,11 +498,11 @@
 	public Property getProperty() {
 		return pProperty;
 	}
-	
+
 	public String getSimpleName() {
 		return this.getProperty().getName();
 	}
-	
+
 	/**
 	 * Gets the symbol.
 	 *
@@ -474,7 +511,7 @@
 	public String getSymbol() {
 		return this.symbol;
 	}
-	
+
 	/**
 	 * Hack frequencies using a map to set forms and frequencies
 	 *
@@ -488,7 +525,7 @@
 		if (map.size() != forms.length) {
 			return false;
 		}
-		
+
 		// super(corpus);
 		int size = map.size();
 		int[] freqs = new int[size];
@@ -496,11 +533,11 @@
 		for (int i = 0; i < forms.length; i++) {
 			freqs[i] = map.get(forms[i]);
 		}
-		
+
 		this.freqs = freqs;
 		return true;
 	}
-	
+
 	/**
 	 * Protected on purpose: should be accessed through others initializer.
 	 *
@@ -511,7 +548,7 @@
 	 *            {@link CQPCorpus#getLexicon(Property)} or
 	 *            {@link Subcorpus#getLexicon(Property)}.
 	 */
-	protected void init(TXMResult corpus, Property property, int[] freq, int[] ids) {
+	protected void init(TXMResult corpus, WordProperty property, int[] freq, int[] ids) {
 		if (freq.length != ids.length) {
 			throw new IllegalArgumentException("wrong size freq.length != ids.length " + freq.length + " != " + ids.length);
 		}
@@ -520,8 +557,8 @@
 		this.forms = getForms();
 		this.pProperty = property;
 	}
-	
-	
+
+
 	/**
 	 * Number of tokens (sum of all the frequencies) in the corpus.
 	 * 
@@ -533,8 +570,8 @@
 		}
 		return numberOfTokens;
 	}
-	
-	
+
+
 	/**
 	 * Number of different types in the frequency list.
 	 * 
@@ -548,14 +585,14 @@
 			return 0;
 		}
 	}
-	
-	public void setParameters(Property property) {
+
+	public void setParameters(WordProperty property) {
 		this.pProperty = property;
 	}
-	
+
 	public boolean setParameters(TXMParameters parameters) {
 		try {
-			Property p = (Property) parameters.get("properties");
+			WordProperty p = (WordProperty) parameters.get("properties");
 			this.setParameters(p);
 		}
 		catch (Exception e) {
@@ -564,7 +601,7 @@
 		}
 		return true;
 	}
-	
+
 	/**
 	 * Sets the symbol.
 	 *
@@ -573,13 +610,13 @@
 	public void setSymbol(String symbol) {
 		this.symbol = symbol;
 	}
-	
-	
+
+
 	@Override
 	public String toString() {
 		return this.getName();
 	}
-	
+
 	/**
 	 * To txt.
 	 *
@@ -605,7 +642,7 @@
 			org.txm.utils.logger.Log.printStackTrace(e1);
 			return false;
 		}
-		
+
 		try {
 			writer.write(this.dump(colseparator, txtseparator));
 			writer.close();
@@ -614,23 +651,23 @@
 			org.txm.utils.logger.Log.printStackTrace(e);
 			return false;
 		}
-		
+
 		return true;
 	}
-	
+
 	/**
 	 * Sets the unit property.
 	 * 
 	 * @param property the unit property
 	 */
-	public void setProperty(Property property) {
+	public void setProperty(WordProperty property) {
 		this.pProperty = property;
 	}
-	
-	
-	public static CQPLexicon getLexicon(CQPCorpus corpus, Property property, TXMProgressMonitor monitor, boolean visible) throws Exception {
+
+
+	public static CQPLexicon getLexicon(CQPCorpus corpus, WordProperty property, TXMProgressMonitor monitor, boolean visible) throws Exception {
 		CQPLexicon lexicon = null;
-		
+
 		// recycling parent Lexicon if exists
 		ArrayList<CQPLexicon> partLexicons = (ArrayList<CQPLexicon>) corpus.getObjectCacheForClass(CQPLexicon.class);
 		for (int i = 0; i < partLexicons.size(); i++) {
@@ -639,20 +676,23 @@
 				break;
 			}
 		}
-		
+
 		// creating new Lexicon
 		if (lexicon == null || !lexicon.getProperty().getFullName().equals(property.getFullName())) {
 			lexicon = new CQPLexicon(corpus);
 			lexicon.setProperty(property);
 			lexicon._compute();
+			
+			// and store it !
+			partLexicons.add(lexicon);
 		}
-		
+
 		Log.finest(TXMCoreMessages.bind("Lexicon = {0} {1}.", lexicon, lexicon.hashCode()));
-		
+
 		return lexicon;
 	}
-	
-	
+
+
 	/**
 	 * Gets a Lexicon from the specified corpus.
 	 * If a Lexicon child exists in the Corpus from the specified property, returns it otherwise creates and computes a new Lexicon.
@@ -662,11 +702,11 @@
 	 * @return
 	 * @throws Exception
 	 */
-	public static CQPLexicon getLexicon(CQPCorpus corpus, Property property, TXMProgressMonitor monitor) throws Exception {
+	public static CQPLexicon getLexicon(CQPCorpus corpus, WordProperty property, TXMProgressMonitor monitor) throws Exception {
 		return getLexicon(corpus, property, monitor, true);
 	}
-	
-	
+
+
 	// /**
 	// * Find or build a lexicon given a Corpus (MainCorpus or SubCorpus).
 	// *
@@ -693,9 +733,9 @@
 	// return null;
 	// }
 	// }
-	
+
 	public CQPCorpus getParent() {
 		return corpus;
-		
+
 	}
 }
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/PositionProperty.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/PositionProperty.java	(revision 0)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/PositionProperty.java	(revision 2948)
@@ -0,0 +1,91 @@
+package org.txm.searchengine.cqp.corpus;
+
+import java.text.NumberFormat;
+import java.util.ArrayList;
+import java.util.List;
+
+import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
+
+/**
+ * A CQP property at token/word level
+ * 
+ * @author mdecorde
+ *
+ */
+public class PositionProperty extends VirtualProperty {
+	
+	int maxLength;
+	NumberFormat f;
+	
+	/**
+	 * Creates a new WordProperty.
+	 * 
+	 * @param name
+	 * @param corpus
+	 */
+	public PositionProperty(CQPCorpus corpus) {
+		super("position", corpus);
+		try {
+			maxLength = Integer.toString(corpus.getMainCorpus().getSize()).length();
+		} catch (CqiClientException e) {
+			e.printStackTrace();
+			maxLength = Integer.toString(Integer.MAX_VALUE).length();
+		}
+		
+		f = NumberFormat.getNumberInstance();
+		f.setMinimumIntegerDigits(maxLength);
+	}
+	
+	public String cpos2Str(int position) {
+		return f.format(position);
+	}
+	
+	public String[] cpos2Str(int[] positions) {
+		return getValues(positions).toArray(new String[positions.length]);
+	}
+	
+	public List<String> getValues(int[] positions) {
+		ArrayList<String> rez = new ArrayList<>();
+		for (int p : positions) {
+			rez.add(cpos2Str(p));
+		}
+		return rez;
+	}
+
+	@Override
+	public int[] cpos2Id(int[] allpositionsarray) {
+		return allpositionsarray; // lol
+	}
+
+	@Override
+	public int cpos2Id(int position) {
+		return position; // lol
+	}
+
+	@Override
+	public String[] id2Str(int[] indices) {
+		String[] rez = new String[indices.length];
+		for (int i = 0 ; i < rez.length ; i++) {
+			rez[i] = cpos2Str(indices[i]);
+		}
+		return rez;
+	}
+
+	@Override
+	public String id2Str(int indice) {
+		return cpos2Str(indice);
+	}
+
+	@Override
+	public String getCQLTest(String value) {
+		// TODO Auto-generated method stub
+		return null;
+	}
+
+	@Override
+	public String getCQLTest(List<String> values) {
+		// TODO Auto-generated method stub
+		return null;
+	}
+}
+

Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/CQPCorpus.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/CQPCorpus.java	(revision 2947)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/CQPCorpus.java	(revision 2948)
@@ -43,6 +43,7 @@
 import org.txm.objects.CorpusCommandPreferences;
 import org.txm.objects.Project;
 import org.txm.searchengine.core.messages.SearchEngineCoreMessages;
+import org.txm.searchengine.cqp.CQPSearchEngine;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.clientExceptions.InvalidCqpIdException;
 import org.txm.searchengine.cqp.core.functions.selection.SelectionResult;
@@ -62,10 +63,13 @@
  * @see org.txm.searchengine.cqp.corpus.MainCorpus
  * @see org.txm.searchengine.cqp.corpus.Subcorpus
  * 
- * @author Jean-Philippe Magué, Sylvain Loiseau
+ * @author Jean-Philippe Magué, Sylvain Loiseau, mdecorde
  */
 public abstract class CQPCorpus extends org.txm.objects.CorpusBuild implements CqpObject {
 	
+	/**
+	 * subresults cache. eg used to store CQP lexicons
+	 */
 	protected static HashMap<Class<?>, ArrayList<?>> cache = new HashMap<>();
 	
 	private static final int CACHE_MAXIMUM_SIZE = 5;
@@ -313,6 +317,8 @@
 	protected StructuralUnit textStructuralUnit;
 	
 	protected WordProperty wordProperty = null;
+
+	private List<VirtualProperty> virtualProperties;
 	
 	/**
 	 * 
@@ -454,6 +460,7 @@
 		charset = "latin1"; //$NON-NLS-1$
 		lang = null;
 		lexicalUnitsProperties = null;
+		virtualProperties = null;
 		size = -1;
 		structuralUnits = null;
 		symbol = null;
@@ -986,18 +993,8 @@
 	public List<Partition> getPartitions() {
 		return getChildren(Partition.class);
 	}
-	
+		
 	/**
-	 * Gets the properties defined for the lexical units of this corpus.
-	 * 
-	 * @return the properties
-	 * 
-	 * @throws CqiClientException
-	 *             the cqi client exception
-	 */
-	public abstract List<WordProperty> getProperties() throws CqiClientException;
-	
-	/**
 	 * Gets the virtual properties of this corpus.
 	 * 
 	 * current implementation only returns the "position" virtual property
@@ -1008,24 +1005,79 @@
 	 *             the cqi client exception
 	 */
 	public List<VirtualProperty> getVirtualProperties() {
-		ArrayList<VirtualProperty> rez = new ArrayList<>();
-		rez.add(new VirtualProperty("position", this));
-		return rez;
+		if (virtualProperties == null) {
+			virtualProperties = new ArrayList<>();
+			virtualProperties.add(new PositionProperty(this));
+			virtualProperties.add(new LengthProperty(this));
+		}
+		return virtualProperties;
 	}
 	
 	/**
-	 * Gets a property from its name.
+	 * Gets the properties available in this corpus.
 	 * 
-	 * @param name
-	 *            the name
+	 * @return the properties
 	 * 
-	 * @return the property
-	 * 
 	 * @throws CqiClientException
 	 *             the cqi client exception
 	 */
-	public abstract WordProperty getProperty(String name) throws CqiClientException;
+	public List<WordProperty> getProperties() throws CqiClientException {
+		if (this.lexicalUnitsProperties != null) {
+			return this.lexicalUnitsProperties;
+		}
+		
+		String[] propertiesName;
+		try {
+			propertiesName = CQPSearchEngine.getCqiClient().corpusPositionalAttributes(this.getMainCorpus().pID);
+		}
+		catch (Exception e) {
+			throw new CqiClientException(e);
+		}
+		
+		List<WordProperty> properties = new ArrayList<>(propertiesName.length);
+		for (int i = 0; i < propertiesName.length; i++) {
+			properties.add(new WordProperty(propertiesName[i], this));
+		}
+		this.lexicalUnitsProperties = properties;
+		return properties;
+	}
 	
+	/*
+	 * (non-Javadoc)
+	 * @see
+	 * org.txm.searchengine.cqp.corpus.Corpus#getProperty(java.lang.
+	 * String)
+	 */
+	public WordProperty getProperty(String name) throws CqiClientException {
+		if (this.lexicalUnitsProperties == null) {
+			getProperties();
+		}
+		
+		int idx = name.indexOf(".");
+		if (idx > 0) { // the name if a qualified name
+			name = name.substring(idx + 1);
+		}
+		
+		if (VirtualProperty.isAVirtualPropertyFullName(name)) {
+			name = VirtualProperty.fullnameToName(name);
+			
+			for (WordProperty property : getVirtualProperties()) {
+				if (property.getName().equals(name)) {
+					return property;
+				}
+			}
+		} else {
+			for (WordProperty property : getProperties()) {
+				if (property.getName().equals(name)) {
+					return property;
+				}
+			}
+		}
+		
+		
+		return null;
+	}
+	
 	@Override
 	public String getSimpleName() {
 		return this.getUserName();
@@ -1418,6 +1470,16 @@
 	}
 	
 	public Property getVirtualProperty(String s) {
-		return new VirtualProperty(s, this);
+		if (s == null || s.length() == 0) {
+			return null;
+		}
+		
+		for (VirtualProperty p : this.getVirtualProperties()) {
+			if (s.equals(p.getName())) {
+				return p;
+			}
+		}
+		
+		return null;
 	}
 }
